﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="Infragistics4.Web.v12.2, Version=12.2.20122.2014, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI" TagPrefix="ig" %>

<%@ Register Assembly="Infragistics4.Web.v12.2, Version=12.2.20122.2014, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script type="text/javascript" src="http://ajax.aspnetcdn.com/ajax/jQuery/jquery-1.7.2.js"></script>
    <script type="text/javascript" id="igClientScript">

        function ValidateSum(source, arguments) {

            var grid = $find("WebHierarchicalDataGrid1");
            for (var k = 0; k < grid.get_gridView().get_rows().get_length() ; k++) {
                var childGrid = grid.get_gridView().get_rows().get_row(k).get_rowIslands();


                if (childGrid != null && childGrid.length > 0) {
                    var rows = childGrid[0].get_behaviors().get_editingCore().get_editedRows();
                    for (var j = 0; j < rows.length; j++) {
                        var currentRow = rows[j];
                        var containerGrid = currentRow.get_grid();

                        var newSum = 0;
                        for (var i = 0; i < containerGrid.get_rows().get_length() ; i++) {
                            var value = containerGrid.get_rows().get_row(i).get_cell(2).get_value();
                            newSum += value;
                        }
                        var parentRow = currentRow.get_grid().get_parentRow();
                        var sumCellValue = parentRow.get_cell(2).get_value();
                        if (sumCellValue != newSum) {

                            arguments.IsValid = false;
                        }
                    }
                }



            }



        }


    </script>
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <ig:WebScriptManager ID="WebScriptManager1" runat="server"></ig:WebScriptManager>
            <ig:WebHierarchicalDataGrid ID="WebHierarchicalDataGrid1" runat="server" Height="350px" Width="400px" DataKeyFields="id"
                OnRowUpdating="WebHierarchicalDataGrid1_RowUpdating" AutoGenerateBands="False">
                <Bands>
                    <ig:Band DataKeyFields="id" AutoGenerateColumns="false" DataMember="Child">
                        <Columns>
                            <ig:BoundDataField DataFieldName="id" Key="id"></ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="Item" Key="Item"></ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="Data" Key="Data"></ig:BoundDataField>

                        </Columns>

                    </ig:Band>

                </Bands>
                <Behaviors>
                    <ig:Activation></ig:Activation>
                    <ig:EditingCore BatchUpdating="true" EnableInheritance="true">

                        <Behaviors>
                            <ig:CellEditing EnableInheritance="true">

                                <ColumnSettings>
                                    <ig:EditingColumnSetting ColumnKey="Sum" ValidatorID="customValidator" />
                                </ColumnSettings>
                            </ig:CellEditing>
                        </Behaviors>
                    </ig:EditingCore>
                </Behaviors>
            </ig:WebHierarchicalDataGrid>
            <asp:Button Text="Save" runat="server" />
            <asp:CustomValidator ID="customValidator" OnServerValidate="ServerValidation" ClientValidationFunction="ValidateSum" ErrorMessage="Sum is incorrect!" runat="server"></asp:CustomValidator>
        </div>
    </form>
</body>
</html>
